using System;
using System.Collections;
using System.Text.RegularExpressions;

namespace GConvert
{
   public class CFoxVar
   {
      protected int m_FOX_VAR;
      protected string m_attr;
      protected NameValuePair[] m_anvp;
      
      public struct NameValuePair
      {
         public string Name;
         public string Value;
      }
      public CFoxVar.NameValuePair this [int nIndex] 
      {
         get{return m_anvp[nIndex];}
         set{m_anvp[nIndex] = value;}
      }
      //-----------------------------------------------------------------------
      public int Length {get{return m_anvp.Length;}}
      //-----------------------------------------------------------------------
      public virtual int FOX_VAR
      {
         get
         {
            for (int i = 0; i < m_anvp.Length; i++)
               if (m_anvp[i].Name == "FOX_VAR")
                  return Convert.ToInt32(m_anvp[i].Value);
            throw new ApplicationException("FOX_VAR does not exist in this CFoxVar instance");
         }
      }
      //-----------------------------------------------------------------------
      public virtual string attr
      {
         get
         {
            for (int i = 0; i < m_anvp.Length; i++)
               if (m_anvp[i].Name == "attr")
                  return m_anvp[i].Value;
            return null;
         }
      }
      //-----------------------------------------------------------------------
      public virtual string conv
      {
         get
         {
            for (int i = 0; i < m_anvp.Length; i++)
               if (m_anvp[i].Name == "conv")
                  return m_anvp[i].Value;
            return null;
         }
      }
      //-----------------------------------------------------------------------
      public string[] entries
      {
         get
         {
            for (int i = 0; i < m_anvp.Length; i++)
               if (m_anvp[i].Name == "entries")
               {
                  return m_anvp[i].Value.Split(new char[] {','});
               }
            return null;
         }
         set
         {
            for (int i = 0; i < m_anvp.Length; i++)
               if (m_anvp[i].Name == "entries")
               {
                  string scEntries = value[0];
                  for (int j = 1; j < value.Length; j++)
                     scEntries += "," + value[j];
                  m_anvp[i].Value = scEntries;
                  break;
               }
         }  // SET
      }

      public CFoxVar(string foxvardata)
      {
         this.m_anvp = disassemble(foxvardata);

//         int   nIndex = 0;
//         m_anvp = new NameValuePair[anvp.Length];
//
//         foreach (NameValuePair nvp in anvp)
//         {
//            switch (nvp.Name)
//            {
//               case "FOX_VAR":
//                  m_FOX_VAR = Convert.ToInt32(nvp.Value);
//                  break;
//               case "attr":
//                  this.m_attr = nvp.Value;
//                  break;
//               default:
//                  m_anvp[nIndex++] = nvp;
//                  break;
//            }
//         }
//         if (nIndex != anvp.Length-2)
//            throw new System.ApplicationException("FOX_VAR Data Syntax Error");
      }

      public override string ToString()
      {
         string scOut = "";

         for (int i = 0; i < this.m_anvp.Length; i++)
         {
            if (i > 0)
               scOut += "^";
            scOut += this.m_anvp[i].Name + "=" + this.m_anvp[i].Value;
         }  // FOR

         return scOut;
      }

      public static NameValuePair[] disassemble(string userdata)
      {
         string[] scaData = userdata.Split(new char[] {'^'});
         //-------------
         // Search for empty elements
         //-------------
         int   nSize = scaData.Length;
         for (int i = 0; i < scaData.Length; i++)
            if (scaData[i].Trim().Length == 0)
               nSize--;

         NameValuePair[] aReturn = new NameValuePair[nSize];
         int   nOutIndex = 0;
         for (int i = 0; i < scaData.Length; i++)
         {
            if (scaData[i].Trim().Length == 0)
               continue;

            try
            {
               int j = scaData[i].Trim().IndexOf('=');
               aReturn[nOutIndex].Name = scaData[i].Substring(0,j);
               aReturn[nOutIndex].Value = scaData[i].Substring(j+1);
            }
            catch (Exception e)
            {
               throw new ApplicationException("Error in \"static:CFoxVar.disassemble\". entry not in <name>=<value> form", e);
            }
            nOutIndex++;
         }  // FOR
         return aReturn;
      }

   }  // CLASS

   /// <summary>
	/// Summary description for CUserdata.
	/// </summary>
	public class CUserdata
	{
      public CFoxVar[]  FoxVars = null;
      public string     EndFoxVar;
      public bool       BaseUserData = false;

      //    . userdata "ftype=BASE^last_foxvar=328^opt=YES^chgflag=1^rev=7^level=0^scan_rate=2^scan_delay=10^display_file=CRUSHING^max_n_stations=0^max_list_size=75^history=1 Tue Dec 13 10:32:21 2005 convert Convert from PDF^what_string=@(#) FDF 6.0 1 Tue Dec 13 10:32:21 2005^overpos=^root_row_origin=6.336807^root_col_origin=0.996094^root_row_extent=68.402779^root_col_extent=114.257812^open_script=ov /usr/common/DISP_MENU -sticky -ontop -l LOW ; ov /usr/common/calculator -sticky -ontop -l TOP ; ^"
      //FOX_VAR=2^attr=TCOLOR^attrval=17^var=CR001:UA003A.ALMSTA^delta=1.000000^conv=BITMASK^type=LONG^num_entries=3^entries=40000000,40000000,ALL,58,4000000,4000000,ALL,31,0,0,ALL,24^FOX_VAR=3^attr=TBLINK^attrval=43^var=CR001:UA003A.ALMSTA^delta=1.000000^conv=BITMASK^type=LONG^num_entries=3^entries=40000000,40000000,ALL,1,4000000,4000000,ALL,0,0,0,ALL,0^FOX_VAR=4^attr=FCOLOR^attrval=6^var=CR001:UA003A.ALMSTA^delta=1.000000^conv=BITMASK^type=LONG^num_entries=4^entries=e0,20,ALL,25,e0,40,ALL,56,e0,60,ALL,61,0,0,ALL,55^END_FOXV=  ^oos_obj=0002
      public CUserdata(string scUserdata)
		{
         int nIndex = scUserdata.IndexOf("END_FOXV");

         if (nIndex < 0)
         {
            //-------------
            // Then probably a BASE userdata line
            //-------------
            GConvert.CFoxVar.NameValuePair[] anvp = CFoxVar.disassemble(scUserdata);
            if (anvp[0].Name == "ftype")
            {
               FoxVars = new CFoxVar[1];
               FoxVars[0] = new CFoxVar(scUserdata);

               BaseUserData = true;
               EndFoxVar = "";
               return;
            }
            //-------------
            // Unrecognised form so throw error
            //-------------
            throw new ApplicationException("Syntax error in UserData. Unrecognised form");
         }  // IF

         ArrayList   alFoxVar = new ArrayList();

         EndFoxVar = scUserdata.Substring(nIndex);
         string   scRemainder = scUserdata.Substring(0, nIndex);

         if (scRemainder.Length > 0)
         {
            do
            {
               nIndex = scRemainder.IndexOf("FOX_VAR", 5);
               if (nIndex > 0)
               {
                  alFoxVar.Add(scRemainder.Substring(0, nIndex));
                  scRemainder = scRemainder.Substring(nIndex);
               }
            }
            while (nIndex > 0);

            //-------------
            // Don't forget the first one
            //-------------
            if (scRemainder.Length > 0)
               alFoxVar.Add(scRemainder);
         }

         FoxVars = new CFoxVar[alFoxVar.Count];
         for (int i = 0; i < alFoxVar.Count; i++)
            FoxVars[i] = new CFoxVar((string)alFoxVar[i]);
		}

      public override string ToString()
      {
         string scOut = "";
         for (int i = 0; i < FoxVars.Length; i++)
            scOut += FoxVars[i].ToString() + "^";
         scOut += this.EndFoxVar;
         return scOut;
      }

	}
}
