using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Data;

namespace GConvert
{
	/// <summary>
	/// Summary description for FormColorConvert.
	/// </summary>
	public class FormColorConvert : System.Windows.Forms.Form
	{
      private System.Windows.Forms.TabControl tabControl1;
      private System.Windows.Forms.TabPage tabEColor;
      private System.Windows.Forms.TabPage tabTColor;
      private System.Windows.Forms.TabPage tabFColor;
      private System.Windows.Forms.Panel panel1;
      private System.Windows.Forms.Button btnOK;
      private System.Windows.Forms.Button btnCancel;

      protected int[] NewEColor = new int[64];
      protected int[] NewFColor = new int[64];
      protected int[] NewTColor = new int[64];

      private System.Windows.Forms.GroupBox[]   gbaEColor = new GroupBox[64];
      private System.Windows.Forms.Panel[]      pnlaEOld = new Panel[64];
      private System.Windows.Forms.Label[]      lblaEGreaterThan = new Label[64];
      private System.Windows.Forms.Panel[]      pnlaENew = new Panel[64];
      private System.Windows.Forms.TextBox[]    txtaENew = new TextBox[64];
      private System.Windows.Forms.GroupBox[]   gbaFColor = new GroupBox[64];
      private System.Windows.Forms.Panel[]      pnlaFOld = new Panel[64];
      private System.Windows.Forms.Label[]      lblaFGreaterThan = new Label[64];
      private System.Windows.Forms.Panel[]      pnlaFNew = new Panel[64];
      private System.Windows.Forms.TextBox[]    txtaFNew = new TextBox[64];
      private System.Windows.Forms.GroupBox[]   gbaTColor = new GroupBox[64];
      private System.Windows.Forms.Panel[]      pnlaTOld = new Panel[64];
      private System.Windows.Forms.Label[]      lblaTGreaterThan = new Label[64];
      private System.Windows.Forms.Panel[]      pnlaTNew = new Panel[64];
      private System.Windows.Forms.TextBox[]    txtaTNew = new TextBox[64];
      private GConvert.FormGColors              frmGColors = null;
      private GConvert.FormMain                 frmMain = null;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

      public FormColorConvert(GConvert.FormGColors frmGColors, GConvert.FormMain frmMain1)
      {
         //
         // Required for Windows Form Designer support
         //
         InitializeComponent();

         frmMain = frmMain1;

         //this.LoadFromReg();
         this.LoadFromDataSource();

         this.frmGColors = frmGColors;

         for (int nRow = 0; nRow < 8; nRow++)
            for (int nCol = 0; nCol < 8; nCol++)
            {
               int i = nRow*8 + nCol;
               this.gbaEColor[i]        = new GroupBox();
               this.pnlaEOld[i]         = new Panel();
               this.lblaEGreaterThan[i] = new Label();
               this.pnlaENew[i]         = new Panel();
               this.txtaENew[i]         = new TextBox();
               this.gbaFColor[i]        = new GroupBox();
               this.pnlaFOld[i]         = new Panel();
               this.lblaFGreaterThan[i] = new Label();
               this.pnlaFNew[i]         = new Panel();
               this.txtaFNew[i]         = new TextBox();
               this.gbaTColor[i]        = new GroupBox();
               this.pnlaTOld[i]         = new Panel();
               this.lblaTGreaterThan[i] = new Label();
               this.pnlaTNew[i]         = new Panel();
               this.txtaTNew[i]         = new TextBox();

               // 
               // GroupBox
               // 
               this.gbaEColor[i].Controls.Add(this.pnlaEOld[i]);
               this.gbaEColor[i].Controls.Add(this.txtaENew[i] );
               this.gbaEColor[i].Controls.Add(this.pnlaENew[i]  );
               this.gbaEColor[i].Controls.Add(this.lblaEGreaterThan[i]);
               this.gbaFColor[i].Controls.Add(this.pnlaFOld[i]);
               this.gbaFColor[i].Controls.Add(this.txtaFNew[i] );
               this.gbaFColor[i].Controls.Add(this.pnlaFNew[i]  );
               this.gbaFColor[i].Controls.Add(this.lblaFGreaterThan[i]);
               this.gbaTColor[i].Controls.Add(this.pnlaTOld[i]);
               this.gbaTColor[i].Controls.Add(this.txtaTNew[i] );
               this.gbaTColor[i].Controls.Add(this.pnlaTNew[i]  );
               this.gbaTColor[i].Controls.Add(this.lblaTGreaterThan[i]);

               this.gbaEColor[i].Location = new System.Drawing.Point(8 + 92*nCol, 8 + 52*nRow);
               this.gbaEColor[i].Name = "gbColor" + Convert.ToString(i);
               this.gbaEColor[i].Size = new System.Drawing.Size(88, 48);
               this.gbaEColor[i].TabIndex = 6 + i;
               this.gbaEColor[i].TabStop = false;
               this.gbaEColor[i].Text = "Color" + i.ToString();
               this.gbaFColor[i].Location = new System.Drawing.Point(8 + 92*nCol, 8 + 52*nRow);
               this.gbaFColor[i].Name = "gbColor" + Convert.ToString(i);
               this.gbaFColor[i].Size = new System.Drawing.Size(88, 48);
               this.gbaFColor[i].TabIndex = 6 + i;
               this.gbaFColor[i].TabStop = false;
               this.gbaFColor[i].Text = "Color" + i.ToString();
               this.gbaTColor[i].Location = new System.Drawing.Point(8 + 92*nCol, 8 + 52*nRow);
               this.gbaTColor[i].Name = "gbColor" + Convert.ToString(i);
               this.gbaTColor[i].Size = new System.Drawing.Size(88, 48);
               this.gbaTColor[i].TabIndex = 6 + i;
               this.gbaTColor[i].TabStop = false;
               this.gbaTColor[i].Text = "Color" + i.ToString();

               this.tabEColor.Controls.Add(this.gbaEColor[i]);
               this.tabFColor.Controls.Add(this.gbaFColor[i]);
               this.tabTColor.Controls.Add(this.gbaTColor[i]);

               // 
               // pnlaOld[i]
               // 
               this.pnlaEOld[i].Location = new System.Drawing.Point(2, 16);
               this.pnlaFOld[i].Location = new System.Drawing.Point(2, 16);
               this.pnlaTOld[i].Location = new System.Drawing.Point(2, 16);
               this.pnlaEOld[i].Name = "panlOld" + Convert.ToString(i);
               this.pnlaFOld[i].Name = "panlOld" + Convert.ToString(i);
               this.pnlaTOld[i].Name = "panlOld" + Convert.ToString(i);
               this.pnlaEOld[i].Size = new System.Drawing.Size(22, 24);
               this.pnlaFOld[i].Size = new System.Drawing.Size(22, 24);
               this.pnlaTOld[i].Size = new System.Drawing.Size(22, 24);
               this.pnlaEOld[i].TabIndex = 2;
               this.pnlaFOld[i].TabIndex = 2;
               this.pnlaTOld[i].TabIndex = 2;
               this.pnlaEOld[i].Tag = i;
               this.pnlaFOld[i].Tag = i;
               this.pnlaTOld[i].Tag = i;
               this.pnlaEOld[i].BackColor = this.frmGColors.ColorFromG(i);
               this.pnlaFOld[i].BackColor = this.frmGColors.ColorFromG(i);
               this.pnlaTOld[i].BackColor = this.frmGColors.ColorFromG(i);
               // 
               // lblaGreaterThan[i]
               // 
               this.lblaEGreaterThan[i].Location = new System.Drawing.Point(20, 16);
               this.lblaEGreaterThan[i].Name =  "lblGreaterThan" + Convert.ToString(i);
               this.lblaEGreaterThan[i].Size = new System.Drawing.Size(16, 24);
               this.lblaEGreaterThan[i].TabIndex = 5;
               this.lblaEGreaterThan[i].Text = ">";
               this.lblaEGreaterThan[i].TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
               this.lblaFGreaterThan[i].Location = new System.Drawing.Point(20, 16);
               this.lblaFGreaterThan[i].Name =  "lblGreaterThan" + Convert.ToString(i);
               this.lblaFGreaterThan[i].Size = new System.Drawing.Size(16, 24);
               this.lblaFGreaterThan[i].TabIndex = 5;
               this.lblaFGreaterThan[i].Text = ">";
               this.lblaFGreaterThan[i].TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
               this.lblaTGreaterThan[i].Location = new System.Drawing.Point(20, 16);
               this.lblaTGreaterThan[i].Name =  "lblGreaterThan" + Convert.ToString(i);
               this.lblaTGreaterThan[i].Size = new System.Drawing.Size(16, 24);
               this.lblaTGreaterThan[i].TabIndex = 5;
               this.lblaTGreaterThan[i].Text = ">";
               this.lblaTGreaterThan[i].TextAlign = System.Drawing.ContentAlignment.MiddleCenter;

               // 
               // pnlaNew[i] 
               // 
               this.pnlaENew[i].Location = new System.Drawing.Point(32, 16);
               this.pnlaENew[i].Name =  "pnlNew" + Convert.ToString(i);
               this.pnlaENew[i].Size = new System.Drawing.Size(22, 24);
               this.pnlaENew[i].TabIndex = 6;
               this.pnlaENew[i].Tag = i;
               this.pnlaENew[i].Click += new System.EventHandler(pnlNew_Click);

               this.pnlaFNew[i].Location = new System.Drawing.Point(32, 16);
               this.pnlaFNew[i].Name =  "pnlNew" + Convert.ToString(i);
               this.pnlaFNew[i].Size = new System.Drawing.Size(22, 24);
               this.pnlaFNew[i].TabIndex = 6;
               this.pnlaFNew[i].Tag = i;
               this.pnlaFNew[i].Click += new System.EventHandler(pnlNew_Click);

               this.pnlaTNew[i].Location = new System.Drawing.Point(32, 16);
               this.pnlaTNew[i].Name =  "pnlNew" + Convert.ToString(i);
               this.pnlaTNew[i].Size = new System.Drawing.Size(22, 24);
               this.pnlaTNew[i].TabIndex = 6;
               this.pnlaTNew[i].Tag = i;
               this.pnlaTNew[i].Click += new System.EventHandler(pnlNew_Click);

               // 
               // txtNew
               // 
               this.txtaENew[i].Location = new System.Drawing.Point(56, 16);
               this.txtaENew[i].Name =  "txtNew" + Convert.ToString(i);
               this.txtaENew[i].Size = new System.Drawing.Size(28, 20);
               this.txtaENew[i].TabIndex = 7;
               this.txtaENew[i].TextChanged += new EventHandler(txtColour_TextChanged);
               this.txtaENew[i].Tag = i;

               this.txtaFNew[i].Location = new System.Drawing.Point(56, 16);
               this.txtaFNew[i].Name =  "txtNew" + Convert.ToString(i);
               this.txtaFNew[i].Size = new System.Drawing.Size(28, 20);
               this.txtaFNew[i].TabIndex = 7;
               this.txtaFNew[i].TextChanged += new EventHandler(txtColour_TextChanged);
               this.txtaFNew[i].Tag = i;

               this.txtaTNew[i].Location = new System.Drawing.Point(56, 16);
               this.txtaTNew[i].Name =  "txtNew" + Convert.ToString(i);
               this.txtaTNew[i].Size = new System.Drawing.Size(28, 20);
               this.txtaTNew[i].TabIndex = 7;
               this.txtaTNew[i].TextChanged += new EventHandler(txtColour_TextChanged);
               this.txtaTNew[i].Tag = i;
            }

         UpdateDisplay();
      
      }

      //=======================================================================
      /// <summary>
      /// 
      /// </summary>
      private void UpdateDisplay()
      {
         for (int i = 0; i < 64; i++)
         {
            // 
            // pnlaNew[i] 
            // 
            this.pnlaENew[i].BackColor = this.frmGColors.ColorFromG(this.NewEColor[i]);
            this.pnlaFNew[i].BackColor = this.frmGColors.ColorFromG(this.NewFColor[i]);
            this.pnlaTNew[i].BackColor = this.frmGColors.ColorFromG(this.NewTColor[i]);

            // 
            // txtNew
            // 
            this.txtaENew[i].Text = this.NewEColor[i].ToString();
            this.txtaFNew[i].Text = this.NewFColor[i].ToString();
            this.txtaTNew[i].Text = this.NewTColor[i].ToString();
         }
      }

      //=======================================================================
      /// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
         this.tabControl1 = new System.Windows.Forms.TabControl();
         this.tabFColor = new System.Windows.Forms.TabPage();
         this.tabEColor = new System.Windows.Forms.TabPage();
         this.tabTColor = new System.Windows.Forms.TabPage();
         this.panel1 = new System.Windows.Forms.Panel();
         this.btnOK = new System.Windows.Forms.Button();
         this.btnCancel = new System.Windows.Forms.Button();
         this.tabControl1.SuspendLayout();
         this.panel1.SuspendLayout();
         this.SuspendLayout();
         // 
         // tabControl1
         // 
         this.tabControl1.Controls.Add(this.tabFColor);
         this.tabControl1.Controls.Add(this.tabEColor);
         this.tabControl1.Controls.Add(this.tabTColor);
         this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
         this.tabControl1.Location = new System.Drawing.Point(0, 0);
         this.tabControl1.Name = "tabControl1";
         this.tabControl1.SelectedIndex = 0;
         this.tabControl1.Size = new System.Drawing.Size(752, 462);
         this.tabControl1.TabIndex = 0;
         // 
         // tabFColor
         // 
         this.tabFColor.Location = new System.Drawing.Point(4, 22);
         this.tabFColor.Name = "tabFColor";
         this.tabFColor.Size = new System.Drawing.Size(744, 436);
         this.tabFColor.TabIndex = 0;
         this.tabFColor.Text = "fcolor";
         // 
         // tabEColor
         // 
         this.tabEColor.Location = new System.Drawing.Point(4, 22);
         this.tabEColor.Name = "tabEColor";
         this.tabEColor.Size = new System.Drawing.Size(744, 436);
         this.tabEColor.TabIndex = 1;
         this.tabEColor.Text = "ecolor";
         // 
         // tabTColor
         // 
         this.tabTColor.Location = new System.Drawing.Point(4, 22);
         this.tabTColor.Name = "tabTColor";
         this.tabTColor.Size = new System.Drawing.Size(744, 436);
         this.tabTColor.TabIndex = 2;
         this.tabTColor.Text = "tcolor";
         // 
         // panel1
         // 
         this.panel1.Controls.Add(this.btnOK);
         this.panel1.Controls.Add(this.btnCancel);
         this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
         this.panel1.Location = new System.Drawing.Point(0, 462);
         this.panel1.Name = "panel1";
         this.panel1.Size = new System.Drawing.Size(752, 32);
         this.panel1.TabIndex = 1;
         // 
         // btnOK
         // 
         this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
         this.btnOK.Location = new System.Drawing.Point(176, 4);
         this.btnOK.Name = "btnOK";
         this.btnOK.TabIndex = 0;
         this.btnOK.Text = "OK";
         this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
         // 
         // btnCancel
         // 
         this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
         this.btnCancel.Location = new System.Drawing.Point(432, 4);
         this.btnCancel.Name = "btnCancel";
         this.btnCancel.TabIndex = 2;
         this.btnCancel.Text = "Cancel";
         // 
         // FormColorConvert
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(752, 494);
         this.Controls.Add(this.tabControl1);
         this.Controls.Add(this.panel1);
         this.Name = "FormColorConvert";
         this.Text = "Colour Conversion";
         this.Load += new System.EventHandler(this.FormColorConvert_Load);
         this.tabControl1.ResumeLayout(false);
         this.panel1.ResumeLayout(false);
         this.ResumeLayout(false);

      }
		#endregion

      private string GetTabPageName(object sender)
      {
         GroupBox   gbParent = (GroupBox)((System.Windows.Forms.Control)sender).Parent;
         return ((TabPage)gbParent.Parent).Text;
      }

      private void pnlNew_Click(object sender, System.EventArgs e)
      {
         System.Windows.Forms.Panel pnl = (Panel)sender;
         if (this.frmGColors.ShowDialog() == DialogResult.OK)
         {
            pnl.BackColor = frmGColors.SelectedColor;
            switch (GetTabPageName(pnl))
            {
               case "ecolor":
                  this.txtaENew[(int)pnl.Tag].Text = frmGColors.SelectedGColor.ToString();
                  break;
               case "fcolor":
                  this.txtaFNew[(int)pnl.Tag].Text = frmGColors.SelectedGColor.ToString();
                  break;
               case "tcolor":
                  this.txtaTNew[(int)pnl.Tag].Text = frmGColors.SelectedGColor.ToString();
                  break;
            }  // SWITCH
         }
      }

//      private void LoadFromReg()
//      {
//         Microsoft.Win32.RegistryKey regKey = Registry.CurrentUser.OpenSubKey(@"LGL\DCS\GConvert\ColorConvert",false);
//
//         if (regKey == null)
//         {
//            for (int i = 0; i < 64; i++)
//            {
//               this.NewEColor[i] = i;
//               this.NewFColor[i] = i;
//               this.NewTColor[i] = i;
//            }
//            return;
//         }
//
//         for (int i = 0; i < 64; i++)
//         {
//            this.NewEColor[i] = (int) regKey.GetValue("E" + i.ToString("00"));
//            this.NewFColor[i] = (int) regKey.GetValue("F" + i.ToString("00"));
//            this.NewTColor[i] = (int) regKey.GetValue("T" + i.ToString("00"));
//         }
//      }

      private void LoadFromDataSource()
      {
         //-------------
         // Initialise to the trivial mapping
         //-------------
         for (int i = 0; i < 64; i++)
         {
            this.NewEColor[i] = i;
            this.NewFColor[i] = i;
            this.NewTColor[i] = i;
         }

         //-------------
         // Read the contents of the read-in xml configuration file.
         //-------------
         foreach (DataRow r in this.frmMain.dsConvert1.ColourConvert.Rows)
         {
            GConvert.dsConvert.ColourConvertRow row = (GConvert.dsConvert.ColourConvertRow) r;

            if ((row.Old < 0) || (row.Old > 63))
               continue;

            switch (row.Param.ToLower())
            {
               case "ecolor":
                  this.NewEColor[row.Old] = row.New;
                  break;
               case "fcolor":
                  this.NewFColor[row.Old] = row.New;
                  break;
               case "tcolor":
                  this.NewTColor[row.Old] = row.New;
                  break;
               default:
                  break;
            }  // SWITCH
         }
      }

//      private void SaveToReg()
//      {
//         Microsoft.Win32.RegistryKey regKey = Registry.CurrentUser.OpenSubKey(@"LGL\DCS\GConvert\ColorConvert",true);
//
//         if (regKey == null)
//         {
//            regKey = Registry.CurrentUser.CreateSubKey("LGL");
//            regKey = regKey.CreateSubKey("DCS");
//            regKey = regKey.CreateSubKey("GConvert");
//            regKey = regKey.CreateSubKey("ColorConvert");
//         }
//
//         for (int i = 0; i < 64; i++)
//         {
//            regKey.SetValue("E" + i.ToString("00"), this.NewEColor[i]);
//            regKey.SetValue("F" + i.ToString("00"), this.NewFColor[i]);
//            regKey.SetValue("T" + i.ToString("00"), this.NewTColor[i]);
//         }
//      }
      private void SaveToDataSource()
      {
         //-------------
         // We create a set of flags to record which rows we find and if
         // necessary modify in the datasource. Those we don't find, we create.
         //-------------
         bool[] ecolors = new bool[64];
         bool[] fcolors = new bool[64];
         bool[] tcolors = new bool[64];

         for (int i = 0; i < 64; i++)
         {
            ecolors[i] = false;
            fcolors[i] = false;
            tcolors[i] = false;
         }

         foreach (DataRow r in this.frmMain.dsConvert1.ColourConvert.Rows)
         {
            GConvert.dsConvert.ColourConvertRow row = (GConvert.dsConvert.ColourConvertRow) r;

            if ((row.Old < 0) || (row.Old > 63))
               continue;

            switch (row.Param.ToLower())
            {
               case "ecolor":
                  row.New = this.NewEColor[row.Old];
                  ecolors[row.Old] = true;
                  break;
               case "fcolor":
                  row.New = this.NewFColor[row.Old];
                  fcolors[row.Old] = true;
                  break;
               case "tcolor":
                  row.New = this.NewTColor[row.Old];
                  tcolors[row.Old] = true;
                  break;
               default:
                  continue;
            }  // SWITCH

         }  // FOREACH

         //-------------
         // Add any missed rows
         //-------------
         for (int i = 0; i < 64; i++)
         {
            if (!ecolors[i])
            {
               GConvert.dsConvert.ColourConvertRow row = this.frmMain.dsConvert1.ColourConvert.NewColourConvertRow();
               row.Param = "ecolor";
               row.Old = i;
               row.New = this.NewEColor[i];
               this.frmMain.dsConvert1.ColourConvert.Rows.Add(row);
            }
            if (!fcolors[i])
            {
               GConvert.dsConvert.ColourConvertRow row = this.frmMain.dsConvert1.ColourConvert.NewColourConvertRow();
               row.Param = "fcolor";
               row.Old = i;
               row.New = this.NewFColor[i];
               this.frmMain.dsConvert1.ColourConvert.Rows.Add(row);
            }
            if (!tcolors[i])
            {
               GConvert.dsConvert.ColourConvertRow row = this.frmMain.dsConvert1.ColourConvert.NewColourConvertRow();
               row.Param = "tcolor";
               row.Old = i;
               row.New = this.NewTColor[i];
               this.frmMain.dsConvert1.ColourConvert.Rows.Add(row);
            }
         }
      }

      private void FormColorConvert_Load(object sender, System.EventArgs e)
      {
         //this.LoadFromReg();
         this.LoadFromDataSource();

         this.UpdateDisplay();
      }

      private void btnOK_Click(object sender, System.EventArgs e)
      {

         // this.SaveToReg();      
         this.SaveToDataSource();
         this.frmMain.SaveAll();
      }

      private void txtColour_TextChanged(object sender, System.EventArgs e)
      {
         TextBox txt = (TextBox)sender;

         try
         {
            int   nGColor = Convert.ToInt32(txt.Text);
            int   i = (int) txt.Tag;

            switch (GetTabPageName(sender))
            {
               case "ecolor":
                  this.pnlaENew[i].BackColor = this.frmGColors.ColorFromG(nGColor);
                  this.NewEColor[i] = nGColor;
                  break;
               case "fcolor":
                  this.pnlaFNew[i].BackColor = this.frmGColors.ColorFromG(nGColor);
                  this.NewFColor[i] = nGColor;
                  break;
               case "tcolor":
                  this.pnlaTNew[i].BackColor = this.frmGColors.ColorFromG(nGColor);
                  this.NewTColor[i] = nGColor;
                  break;
            }  // SWITCH
         }  // TRY
         catch
         {
         }
      }

      public int NewGColor(string scProperty, int nOldGColor)
      {
         switch (scProperty)
         {
            case "ecolor":
               return this.NewEColor[nOldGColor];
            case "fcolor":
               return this.NewFColor[nOldGColor];
            case "tcolor":
               return this.NewTColor[nOldGColor];
            default:
               return -1;
         }  // SWITCH
      }
	}
}
