using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text.RegularExpressions;
using Microsoft.Win32;

namespace GConvert
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
      private System.Windows.Forms.Panel panel1;
      private System.Windows.Forms.Label label1;
      private System.Windows.Forms.Button btnBrowse;
      private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
      private System.Windows.Forms.TextBox txtBaseDir;
      private System.Windows.Forms.Button btnConvert;
      private System.Windows.Forms.ListBox lbFiles;
      private System.Windows.Forms.Button btnScan;
      private System.Windows.Forms.StatusBar sBar;
      private System.ComponentModel.IContainer components;
      private System.Windows.Forms.MainMenu mainMenu1;
      private System.Windows.Forms.MenuItem mnuFile;
      private System.Windows.Forms.MenuItem mnuFileScan;
      private System.Windows.Forms.MenuItem menuItem1;
      private System.Windows.Forms.MenuItem mnuFileExit;
      private System.Windows.Forms.MenuItem mnuConfig;
      private System.Windows.Forms.MenuItem mnuConfigFontConvert;
      private System.Windows.Forms.MenuItem mnuConfigColourConvert;
      private System.Windows.Forms.MenuItem mnuConfigPathConvert;
      private System.Windows.Forms.TreeView treeView1;
      private System.Windows.Forms.Splitter splitter1;
      private System.Windows.Forms.Button btnConvertAll;
      private System.Windows.Forms.ImageList imageList1;

      private GConvert.FormColorConvert frmColourConvert = null;
      private GConvert.FormFontConvert frmFontConvert = null;
      private GConvert.FormGColors     frmGColors = null;
      private GConvert.FormPathConvert frmPathConvert = null;
      public  GConvert.dsConvert       dsConvert1 = null;
      private GConvert.dsConvert       dsConvertFileLoc = null;

      private string m_LogFile;

		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

         this.dsConvert1 = new dsConvert();

         this.LoadAll();

			this.frmFontConvert     = new FormFontConvert(this);
         this.frmGColors         = new FormGColors();
         this.frmColourConvert   = new FormColorConvert(this.frmGColors, this);
         this.frmPathConvert     = new FormPathConvert(this);

         m_LogFile = Directory.GetCurrentDirectory() + @"\GConvert.log";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
         this.components = new System.ComponentModel.Container();
         System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
         this.panel1 = new System.Windows.Forms.Panel();
         this.btnConvertAll = new System.Windows.Forms.Button();
         this.btnScan = new System.Windows.Forms.Button();
         this.btnConvert = new System.Windows.Forms.Button();
         this.btnBrowse = new System.Windows.Forms.Button();
         this.label1 = new System.Windows.Forms.Label();
         this.txtBaseDir = new System.Windows.Forms.TextBox();
         this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
         this.lbFiles = new System.Windows.Forms.ListBox();
         this.sBar = new System.Windows.Forms.StatusBar();
         this.mainMenu1 = new System.Windows.Forms.MainMenu();
         this.mnuFile = new System.Windows.Forms.MenuItem();
         this.mnuFileScan = new System.Windows.Forms.MenuItem();
         this.menuItem1 = new System.Windows.Forms.MenuItem();
         this.mnuFileExit = new System.Windows.Forms.MenuItem();
         this.mnuConfig = new System.Windows.Forms.MenuItem();
         this.mnuConfigFontConvert = new System.Windows.Forms.MenuItem();
         this.mnuConfigColourConvert = new System.Windows.Forms.MenuItem();
         this.mnuConfigPathConvert = new System.Windows.Forms.MenuItem();
         this.treeView1 = new System.Windows.Forms.TreeView();
         this.imageList1 = new System.Windows.Forms.ImageList(this.components);
         this.splitter1 = new System.Windows.Forms.Splitter();
         this.panel1.SuspendLayout();
         this.SuspendLayout();
         // 
         // panel1
         // 
         this.panel1.Controls.Add(this.btnConvertAll);
         this.panel1.Controls.Add(this.btnScan);
         this.panel1.Controls.Add(this.btnConvert);
         this.panel1.Controls.Add(this.btnBrowse);
         this.panel1.Controls.Add(this.label1);
         this.panel1.Controls.Add(this.txtBaseDir);
         this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
         this.panel1.Location = new System.Drawing.Point(0, 0);
         this.panel1.Name = "panel1";
         this.panel1.Size = new System.Drawing.Size(616, 32);
         this.panel1.TabIndex = 0;
         // 
         // btnConvertAll
         // 
         this.btnConvertAll.Location = new System.Drawing.Point(536, 8);
         this.btnConvertAll.Name = "btnConvertAll";
         this.btnConvertAll.Size = new System.Drawing.Size(72, 22);
         this.btnConvertAll.TabIndex = 5;
         this.btnConvertAll.Text = "Convert All";
         this.btnConvertAll.Click += new System.EventHandler(this.btnConvertAll_Click);
         // 
         // btnScan
         // 
         this.btnScan.Location = new System.Drawing.Point(416, 8);
         this.btnScan.Name = "btnScan";
         this.btnScan.Size = new System.Drawing.Size(48, 22);
         this.btnScan.TabIndex = 4;
         this.btnScan.Text = "Scan";
         this.btnScan.Click += new System.EventHandler(this.btnScan_Click);
         // 
         // btnConvert
         // 
         this.btnConvert.Location = new System.Drawing.Point(464, 8);
         this.btnConvert.Name = "btnConvert";
         this.btnConvert.Size = new System.Drawing.Size(72, 22);
         this.btnConvert.TabIndex = 3;
         this.btnConvert.Text = "Convert";
         this.btnConvert.Click += new System.EventHandler(this.btnConvert_Click);
         // 
         // btnBrowse
         // 
         this.btnBrowse.Location = new System.Drawing.Point(392, 8);
         this.btnBrowse.Name = "btnBrowse";
         this.btnBrowse.Size = new System.Drawing.Size(24, 22);
         this.btnBrowse.TabIndex = 2;
         this.btnBrowse.Text = "...";
         this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
         // 
         // label1
         // 
         this.label1.Location = new System.Drawing.Point(8, 8);
         this.label1.Name = "label1";
         this.label1.Size = new System.Drawing.Size(56, 16);
         this.label1.TabIndex = 1;
         this.label1.Text = "Base Dir:";
         this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
         // 
         // txtBaseDir
         // 
         this.txtBaseDir.Location = new System.Drawing.Point(68, 8);
         this.txtBaseDir.Name = "txtBaseDir";
         this.txtBaseDir.Size = new System.Drawing.Size(324, 20);
         this.txtBaseDir.TabIndex = 0;
         this.txtBaseDir.Text = "C:\\DCS\\g_files";
         // 
         // lbFiles
         // 
         this.lbFiles.Dock = System.Windows.Forms.DockStyle.Fill;
         this.lbFiles.IntegralHeight = false;
         this.lbFiles.Location = new System.Drawing.Point(203, 32);
         this.lbFiles.MultiColumn = true;
         this.lbFiles.Name = "lbFiles";
         this.lbFiles.Size = new System.Drawing.Size(413, 392);
         this.lbFiles.TabIndex = 1;
         this.lbFiles.SelectedIndexChanged += new System.EventHandler(this.lbFiles_SelectedIndexChanged);
         // 
         // sBar
         // 
         this.sBar.Location = new System.Drawing.Point(0, 424);
         this.sBar.Name = "sBar";
         this.sBar.Size = new System.Drawing.Size(616, 22);
         this.sBar.TabIndex = 2;
         // 
         // mainMenu1
         // 
         this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                  this.mnuFile,
                                                                                  this.mnuConfig});
         // 
         // mnuFile
         // 
         this.mnuFile.Index = 0;
         this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                this.mnuFileScan,
                                                                                this.menuItem1,
                                                                                this.mnuFileExit});
         this.mnuFile.Text = "&File";
         // 
         // mnuFileScan
         // 
         this.mnuFileScan.Index = 0;
         this.mnuFileScan.Text = "&Scan";
         this.mnuFileScan.Click += new System.EventHandler(this.mnuFileScan_Click);
         // 
         // menuItem1
         // 
         this.menuItem1.Index = 1;
         this.menuItem1.Text = "-";
         // 
         // mnuFileExit
         // 
         this.mnuFileExit.Index = 2;
         this.mnuFileExit.Text = "E&xit";
         this.mnuFileExit.Click += new System.EventHandler(this.mnuFileExit_Click);
         // 
         // mnuConfig
         // 
         this.mnuConfig.Index = 1;
         this.mnuConfig.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                  this.mnuConfigFontConvert,
                                                                                  this.mnuConfigColourConvert,
                                                                                  this.mnuConfigPathConvert});
         this.mnuConfig.Text = "&Config";
         // 
         // mnuConfigFontConvert
         // 
         this.mnuConfigFontConvert.Index = 0;
         this.mnuConfigFontConvert.Text = "&Font Conversion...";
         this.mnuConfigFontConvert.Click += new System.EventHandler(this.mnuConfigFontConvert_Click);
         // 
         // mnuConfigColourConvert
         // 
         this.mnuConfigColourConvert.Index = 1;
         this.mnuConfigColourConvert.Text = "&Colour Conversion...";
         this.mnuConfigColourConvert.Click += new System.EventHandler(this.mnuConfigColourConvert_Click);
         // 
         // mnuConfigPathConvert
         // 
         this.mnuConfigPathConvert.Index = 2;
         this.mnuConfigPathConvert.Text = "&Path Conversion...";
         this.mnuConfigPathConvert.Click += new System.EventHandler(this.mnuConfigPathConvert_Click);
         // 
         // treeView1
         // 
         this.treeView1.Dock = System.Windows.Forms.DockStyle.Left;
         this.treeView1.ImageList = this.imageList1;
         this.treeView1.Location = new System.Drawing.Point(0, 32);
         this.treeView1.Name = "treeView1";
         this.treeView1.Size = new System.Drawing.Size(200, 392);
         this.treeView1.TabIndex = 3;
         this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
         // 
         // imageList1
         // 
         this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
         this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
         this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
         // 
         // splitter1
         // 
         this.splitter1.Location = new System.Drawing.Point(200, 32);
         this.splitter1.Name = "splitter1";
         this.splitter1.Size = new System.Drawing.Size(3, 392);
         this.splitter1.TabIndex = 4;
         this.splitter1.TabStop = false;
         // 
         // FormMain
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(616, 446);
         this.Controls.Add(this.lbFiles);
         this.Controls.Add(this.splitter1);
         this.Controls.Add(this.treeView1);
         this.Controls.Add(this.sBar);
         this.Controls.Add(this.panel1);
         this.Menu = this.mainMenu1;
         this.Name = "FormMain";
         this.Text = "G File Converter";
         this.Load += new System.EventHandler(this.FormMain_Load);
         this.panel1.ResumeLayout(false);
         this.ResumeLayout(false);

      }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

      private void btnBrowse_Click(object sender, System.EventArgs e)
      {
         this.folderBrowserDialog1.SelectedPath = this.txtBaseDir.Text;
         if (this.folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            this.txtBaseDir.Text = this.folderBrowserDialog1.SelectedPath;
      }

      private void btnScan_Click(object sender, System.EventArgs e)
      {
         if (!Directory.Exists(this.txtBaseDir.Text))
            MessageBox.Show("Dir not found", "Error");

         this.lbFiles.Items.Clear();

         DirectoryInfo dir = new DirectoryInfo(this.txtBaseDir.Text);
         AddFilesToList(dir, null);
      }

      private void AddFilesToList(DirectoryInfo dir, System.Windows.Forms.TreeNode treeNode)
      {
         TreeNode childNode;
//         FileInfo[] files = dir.GetFiles("*.g");
//
//         foreach (FileInfo file in files)
//         {
//            //this.lbFiles.Items.Add(file);
//            childNode = new TreeNode(file.Name, 0, 0);
//            childNode.Tag = file;
//            if (treeNode == null)
//               this.treeView1.Nodes.Add(childNode);
//            else
//               treeNode.Nodes.Add(childNode);
//         }

         DirectoryInfo[] subDirs = dir.GetDirectories();
         foreach (DirectoryInfo subDir in subDirs)
         {
            // AddFilesToList(subDir);
            childNode = new TreeNode(subDir.Name, 1, 2);
            childNode.Tag = subDir;
            if (treeNode == null)
               this.treeView1.Nodes.Add(childNode);
            else
               treeNode.Nodes.Add(childNode);
            AddFilesToList(subDir, childNode);
         }
      }

      private void lbFiles_SelectedIndexChanged(object sender, System.EventArgs e)
      {
         if (this.lbFiles.SelectedItems.Count == 1)
         {
            FileInfo file = (FileInfo)this.lbFiles.SelectedItem;
            this.sBar.Text = file.FullName;
         }
      }

      private void btnConvertSettings_Click(object sender, System.EventArgs e)
      {
         this.frmFontConvert.ShowDialog();
      }

      private void btnConvert_Click(object sender, System.EventArgs e)
      {
         for (int i = 0; i < this.lbFiles.SelectedItems.Count; i++)
         {
            FileInfo fi = (FileInfo)this.lbFiles.SelectedItems[i];
            this.sBar.Text = "Converting " + fi.Name;
            FileInfo fiOut = this.ConvertFile(fi, false);
            this.sBar.Text = "Finished " + fi.Name + " as " + fiOut.Name;
         }
      }

      static Regex rgxHeightProperty = new Regex("^\\s*height (-?\\d+\\.\\d+)$",RegexOptions.None);
      static Regex rgxSimpleIntProperty = new Regex("^(\\s*)(\\w+) (\\d+)$",RegexOptions.None);
      static Regex rgxUserdata = new Regex("^(\\s*\\. userdata )\"(.+)\"$", RegexOptions.None);
      static Regex rgxText = new Regex("^(\\s*)ftrect (-?\\d{1,3}\\.\\d{0,6}) (-?\\d{1,3}\\.\\d{0,6}) (-?\\d{1,3}\\.\\d{0,6}) (-?\\d{1,3}\\.\\d{0,6})\\s+\"(.*)\"$",RegexOptions.None);

      static Regex rgxFVPath = new Regex("(/opt/[\\w\\d/_]+)(\\.fdf)?");            // eg: /opt/customer/common/SOL_VALVE.fdf
      static Regex rgxFilePath = new Regex("(/opt/[\\w\\d/_]+)");                   // eg: /opt/customer/common/SOL_VALVE
      static Regex rgxFileSubPath = new Regex("(/opt/[\\w\\d/_]+)(\\$[\\w\\d_]+)?(\\.fdf)?"); // eg: /opt/customer/valve/$p5

      //=======================================================================
      /// <summary>
      /// 
      /// </summary>
      /// <param name="fi"></param>
      private FileInfo ConvertFile(FileInfo fi, bool bPutInNewLocation)
      {
         if (!fi.Exists)
            throw new FileNotFoundException("File not found", fi.FullName);

         int      nCount = 1;
         FileInfo fiOut = null;
         int      nInLineCount = 0;
         int      nOutLineCount = 0;

         //-------------
         // Log File
         //-------------
         if (bPutInNewLocation)
         {
            //-------------
            // Figure out what the new name for the file will be by looking in the
            // path substitution list until we find an entry in the 'Old' list
            // in our file name. Then we substitute with the new list. If we don't
            // find an entry, we don't proceed.
            //-------------
            string scOldName = fi.FullName;
            int   nIndex = -1;
            DataView dv = new DataView(this.dsConvertFileLoc.PathConvert, "", "Order", DataViewRowState.CurrentRows);
            foreach (DataRowView drv in dv)
            {
               GConvert.dsConvert.PathConvertRow row = (GConvert.dsConvert.PathConvertRow)drv.Row;

               nIndex = scOldName.IndexOf(row.Old);
               if (nIndex > 0)
               {
                  string   scNewName = scOldName.Substring(0, nIndex) + row.New + scOldName.Substring(nIndex + row.Old.Length);
                  fiOut = new FileInfo(scNewName);
                  break;
               }
            }  // FOREACH
         }  // IF
         else
         {
            do
            {
               string   scNewName = fi.DirectoryName + "\\" + fi.Name.Substring(0,fi.Name.Length-fi.Extension.Length) + "." + nCount.ToString() + fi.Extension;
               fiOut = new FileInfo(scNewName);
               nCount++;
            }
            while (fiOut.Exists);
         }

         if (fiOut == null)
            return null;

         System.IO.StreamWriter swLogFile = new StreamWriter(m_LogFile, true);
         swLogFile.WriteLine(DateTime.Now.ToString("d-MMM-y hh:mm:ss") + " - Creating file \"" + fiOut.FullName + "\" from \"" + fi.FullName + "\"");

         System.IO.StreamReader sr = new StreamReader(fi.FullName);
         System.IO.StreamWriter sw;
         try
         {
            sw = new StreamWriter(fiOut.FullName, false);
         }
         catch
         {
            //-------------
            // The directory probably needs to be created
            //-------------
            Directory.CreateDirectory(fiOut.DirectoryName);
            sw = new StreamWriter(fiOut.FullName, false);
         }
         try
         {
            string   scLine;
            double   heightIn = 0.0;
            double   heightOut = 0.0;
            int      fontIn = -1;
            int      fontOut = -1;

            while ((scLine = sr.ReadLine()) != null)
            {
               nInLineCount++;
               try
               {
                  Match match;

                  #region Simple parameters
                  //-------------
                  // Look for a floating point height property
                  //-------------
                  match = rgxHeightProperty.Match(scLine);
                  if (match.Success)
                  {
                     heightIn = Convert.ToDouble(match.Groups[1].Value);
                     continue;
                  }

                  //-------------
                  // Look for an integer property
                  //-------------
                  match = rgxSimpleIntProperty.Match(scLine);
                  if (match.Success)
                  {
                     string   scProperty = match.Groups[2].Value;
                     int      nValue = Convert.ToInt32(match.Groups[3].Value);

                     switch (scProperty)
                     {
                        case "ecolor":
                        case "fcolor":
                        case "tcolor":
                           nValue = this.frmColourConvert.NewGColor(scProperty, nValue);
                           sw.WriteLine(match.Groups[1].Value + scProperty + " " + nValue.ToString());
                           nOutLineCount++;
                           break;
                        case "font":
                           fontIn = nValue;
                           break;
                        default:
                           sw.WriteLine(scLine);
                           nOutLineCount++;
                           break;
                     }
                     continue;
                  }
                  #endregion
                  #region Text Element
                  //-------------
                  // Look for a text element
                  //-------------
                  match = rgxText.Match(scLine);
                  if (match.Success)
                  {
                     double   x1, x2, y1, y2;
                     x1 = Convert.ToDouble(match.Groups[2].Value);
                     y1 = Convert.ToDouble(match.Groups[3].Value);
                     x2 = Convert.ToDouble(match.Groups[4].Value);
                     y2 = Convert.ToDouble(match.Groups[5].Value);
                     double rectWidth = (x2 - x1);
                     double rectHeight = y1 - y2;
                     double rectOffsetX = 0.0;
                     double rectOffsetY = 0.0;
                     double dNewHeight;
                     string scText = match.Groups[6].Value;
                     int   nNewFont;

                     if (heightIn > 1.69999 && heightIn < 1.70001)
                     {
                        // case 1.7:      // Table2Font3
                        rectWidth *= this.frmFontConvert.Scale23X;
                        rectHeight *= this.frmFontConvert.Scale23Y;
                        rectOffsetX = this.frmFontConvert.Offset23X;
                        rectOffsetY = this.frmFontConvert.Offset23Y;
                        dNewHeight = this.frmFontConvert.Height23;
                        nNewFont = this.frmFontConvert.Font23;
                     }
                     else if (heightIn > 1.1 && heightIn < 1.10002)
                     {
                        // case 1.10001:  // Table0Font0 or Table2Font2
                        rectWidth *= this.frmFontConvert.Scale00X;
                        rectHeight *= this.frmFontConvert.Scale00Y;
                        rectOffsetX = this.frmFontConvert.Offset00X;
                        rectOffsetY = this.frmFontConvert.Offset00Y;
                        dNewHeight = this.frmFontConvert.Height00;
                        nNewFont = this.frmFontConvert.Font00;
                     }
                     else if (heightIn > 1.79999 && heightIn < 1.80001)
                     {
                        // case 1.8:      // Table0Font1
                        rectWidth *= this.frmFontConvert.Scale01X;
                        rectHeight *= this.frmFontConvert.Scale01Y;
                        rectOffsetX = this.frmFontConvert.Offset01X;
                        rectOffsetY = this.frmFontConvert.Offset01Y;
                        dNewHeight = this.frmFontConvert.Height01;
                        nNewFont = this.frmFontConvert.Font01;
                     }
                     else if (heightIn > 0.89999 && heightIn < 0.90000)
                     {
                        // case 0.899994: // Table0Font2 or Table2Font0
                        rectWidth *= this.frmFontConvert.Scale02X;
                        rectHeight *= this.frmFontConvert.Scale02Y;
                        rectOffsetX = this.frmFontConvert.Offset02X;
                        rectOffsetY = this.frmFontConvert.Offset02Y;
                        dNewHeight = this.frmFontConvert.Height02;
                        nNewFont = this.frmFontConvert.Font02;
                     }
                     else if (heightIn > 2.29999 && heightIn < 2.30001)
                     {
                        // case 2.3:      // Table0Font3
                        rectWidth *= this.frmFontConvert.Scale03X;
                        rectHeight *= this.frmFontConvert.Scale03Y;
                        rectOffsetX = this.frmFontConvert.Offset03X;
                        rectOffsetY = this.frmFontConvert.Offset03Y;
                        dNewHeight = this.frmFontConvert.Height03;
                        nNewFont = this.frmFontConvert.Font03;
                     }
                     else if (heightIn > 1.39998 && heightIn < 1.40000)
                     {
                        // case 1.39999:  // Table2Font1
                        rectWidth *= this.frmFontConvert.Scale21X;
                        rectHeight *= this.frmFontConvert.Scale21Y;
                        rectOffsetX = this.frmFontConvert.Offset21X;
                        rectOffsetY = this.frmFontConvert.Offset21Y;
                        dNewHeight = this.frmFontConvert.Height21;
                        nNewFont = this.frmFontConvert.Font21;
                     }
                     else
                     {
                        if (heightIn != heightOut)
                        {
                           sw.WriteLine(match.Groups[1].Value + "height " + heightIn.ToString("0.######"));
                           heightOut = heightIn;
                           nOutLineCount++;
                        }
                        if (fontIn != fontOut)
                        {
                           sw.WriteLine(match.Groups[1].Value + "height " + fontIn.ToString());
                           fontOut = fontIn;
                           nOutLineCount++;
                        }
                        sw.WriteLine(scLine);
                        nOutLineCount++;
                        continue;
                     }

                     string scOut;

                     if (heightOut != dNewHeight)
                     {
                        scOut = match.Groups[1].Value + "height " + dNewHeight.ToString("0.######");
                        sw.WriteLine(scOut);
                        nOutLineCount++;
                        heightOut = dNewHeight;
                     }
                     if (fontOut != nNewFont)
                     {
                        scOut = match.Groups[1].Value + "font " + nNewFont.ToString();
                        sw.WriteLine(scOut);
                        nOutLineCount++;
                        fontOut = nNewFont;
                     }

                     x1 += rectOffsetX;
                     y1 += rectOffsetY;

                     x2 = x1 + rectWidth;
                     y2 = y1 - rectHeight;

                     scOut = match.Groups[1].Value + "ftrect " + x1.ToString("0.####") + " " + y1.ToString("0.####") + " " + x2.ToString("0.####") + " " + y2.ToString("0.####") + "  \"" + scText + "\"";
                     sw.WriteLine(scOut);
                     nOutLineCount++;

                     continue;
                  }
                  #endregion
                  #region Userdata
                  //-------------
                  // Userdata
                  //-------------
                  match = rgxUserdata.Match(scLine);
                  if (match.Success)
                  {
                     //-------------
                     // We work through each element in the old list looking for
                     // it's existence in the value portion of this userdata. If
                     // found, we replace the new equivalent.
                     //-------------
                     string userdata = match.Groups[2].Value;
                     DataView dv = new DataView(this.dsConvert1.PathConvert, "", "Order", DataViewRowState.CurrentRows);
                     foreach (DataRowView drv in dv)
                     {
                        int   nIndex;

                        GConvert.dsConvert.PathConvertRow row = (GConvert.dsConvert.PathConvertRow)drv.Row;
                        do
                        {
                           nIndex = userdata.IndexOf(row.Old);
                           if (nIndex > 0)
                           {
                              userdata = userdata.Substring(0, nIndex) + row.New + userdata.Substring(nIndex+row.Old.Length);

                              //-------------
                              // Also, at this point, we want to change the name
                              // of the display file from the DM form (no extension)
                              // to the FV form with an fdf extension.
                              // We look for any paths and substitute. Must be
                              // aware that two common variants include:
                              // /opt/customer/common/SOL_VALVE
                              //   and
                              // /opt/customer/valve/$p5
                              //-------------
                              Match match2 = rgxFileSubPath.Match(userdata, nIndex);
                              if (match2.Success)
                              {
                                 if ((match2.Groups.Count > 3) && (match2.Groups[3].Value != ""))
                                    continue;

                                 string   scBefore = userdata.Substring(0, nIndex + match2.Groups[0].Value.Length);
                                 string   scAfter = userdata.Substring(nIndex + match2.Groups[0].Value.Length);
                                 userdata = scBefore + ".fdf" + scAfter;
                              }
                           }
                        }
                        while (nIndex > 0);
                     }  // FOREACH

                     //-------------
                     // Next we break down into it's component parts and look for TCOLOR, ECOLOR or FCOLOR dynamics
                     //-------------
                     GConvert.CUserdata cUserdata = new CUserdata(userdata);

                     for (int i = 0; i < cUserdata.FoxVars.Length; i++)
                     {
                        string[] scaEntries;

                        switch (cUserdata.FoxVars[i].attr)
                        {
                           case "ECOLOR":
                           case "FCOLOR":
                           case "TCOLOR":
                              scaEntries = cUserdata.FoxVars[i].entries;
                              if (scaEntries != null)
                              {
                                 //-------------
                                 // Every 4th element is a color number
                                 //-------------
                                 for (int k = 3; k < scaEntries.Length; k+=4)
                                 {
                                    int   nValue = Convert.ToInt32(scaEntries[k]);
                                    nValue = this.frmColourConvert.NewGColor(cUserdata.FoxVars[i].attr.ToLower(), nValue);
                                    scaEntries[k] = nValue.ToString();
                                 }  // FOR
                                 cUserdata.FoxVars[i].entries = scaEntries;
                              }
                              break;
                           default:
                              break;
                        }  // SWITCH
                     }  // FOR

                     sw.WriteLine(match.Groups[1].Value + "\"" + cUserdata.ToString() + "\"");
                     nOutLineCount++;
                     continue;
                  }
                  #endregion
               }  // TRY
               catch (Exception e)
               {
                  swLogFile.WriteLine("   Error (Line " + nInLineCount.ToString() + "):" + e.Message);
               }

               sw.WriteLine(scLine);
               nOutLineCount++;
            }  // WHILE
         }
         finally
         {
            sr.Close();
            sw.Close();
            swLogFile.WriteLine("Processed " + nInLineCount.ToString() + " lines.");
            swLogFile.Flush();
            swLogFile.Close();
         }

         return fiOut;
      }

      private void mnuFileExit_Click(object sender, System.EventArgs e)
      {
         this.SaveAll();
         Close();
      }

      private void mnuConfigFontConvert_Click(object sender, System.EventArgs e)
      {
         this.frmFontConvert.ShowDialog();
      }

      private void mnuConfigColourConvert_Click(object sender, System.EventArgs e)
      {
         this.frmColourConvert.ShowDialog();
      }

      private void mnuConfigPathConvert_Click(object sender, System.EventArgs e)
      {
         this.frmPathConvert.ShowDialog();
      }

      private void mnuFileScan_Click(object sender, System.EventArgs e)
      {
         btnScan_Click(sender, e);
      }

      private void treeView1_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
      {
         if ((e.Action == TreeViewAction.Collapse) || (e.Action == TreeViewAction.Expand))
            return;

         TreeNode treeNode;
         DirectoryInfo dir;
         try
         {
            treeNode = e.Node;
            dir = (DirectoryInfo)treeNode.Tag;
         }
         catch
         {
            return;
         }

         FileInfo[] files = dir.GetFiles("*.g");

         this.lbFiles.Items.Clear();
         foreach (FileInfo file in files)
            this.lbFiles.Items.Add(file);
      }

      private void btnConvertAll_Click(object sender, System.EventArgs e)
      {
         //-------------
         // We only convert all files in the usr directory and child directories.
         // We make the changes and save the changes to the new locations according
         // to the substitution list.
         // Unfortunately the unix path has forward slashes. Windows paths have
         // backslahses. So we create a new dataset for the purposes of file location
         // changes.
         //-------------
         this.dsConvertFileLoc = new dsConvert();
         foreach (DataRow r in this.dsConvert1.PathConvert.Rows)
         {
            GConvert.dsConvert.PathConvertRow row = (GConvert.dsConvert.PathConvertRow) r;
            string scOld = row.Old;
            string scNew = row.New;

            scOld = scOld.Replace('/','\\');
            scNew = scNew.Replace('/','\\');
            GConvert.dsConvert.PathConvertRow newRow = dsConvertFileLoc.PathConvert.NewPathConvertRow();
            newRow.Old = scOld;
            newRow.New = scNew;
            this.dsConvertFileLoc.PathConvert.Rows.Add(newRow);
         }

         //-------------
         // OK. Recursively convert the files.
         //-------------
         foreach (TreeNode tn in this.treeView1.Nodes)
         {
            if (tn.Text == "usr")
            {
               this.ConvertRecursive(tn);
               this.sBar.Text = "Finished";
               this.Update();
               break;
            }
         }

         //-------------
         // Restore the original PathConvert database
         //-------------
         //this.frmPathConvert.dsConvert1 = temp_dsConvert;
      }

      //=======================================================================
      /// <summary>
      /// 
      /// </summary>
      /// <param name="tn"></param>
      private void ConvertRecursive(TreeNode tn)
      {
         DirectoryInfo  dir;
         try
         {
            dir = (DirectoryInfo) tn.Tag;
         }
         catch
         {
            return;
         }

         FileInfo[] files = dir.GetFiles("*.g");
         foreach (FileInfo fi in files)
         {
            this.sBar.Text = "Converting " + fi.Name;
            this.sBar.Update();

            this.ConvertFile(fi, true);
         }

         foreach (TreeNode childNode in tn.Nodes)
         {
            ConvertRecursive(childNode);
         }
      }

      private void FormMain_Load(object sender, System.EventArgs e)
      {
      
      }
      public void SaveAll()
      {
         this.dsConvert1.WriteXml(Directory.GetCurrentDirectory() + @"\PathConvert1745.xml", XmlWriteMode.IgnoreSchema);

         Microsoft.Win32.RegistryKey regKey = Registry.CurrentUser.OpenSubKey(@"LGL\DCS\GConvert",true);

         if (regKey == null)
            return;

         regKey.SetValue("BasePath", this.txtBaseDir.Text);
      }

      //=======================================================================
      /// <summary>
      /// 
      /// </summary>
      public void LoadAll()
      {
         try
         {
            dsConvert1.ReadXml(Directory.GetCurrentDirectory() + @"\PathConvert1745.xml", XmlReadMode.IgnoreSchema);
         }
         catch (Exception e)
         {
            MessageBox.Show("Could not open configuration file \"" + Directory.GetCurrentDirectory() + @"\PathConvert1745.xml" + "\"" + ":" + e.Message);
         }

         Microsoft.Win32.RegistryKey regKey = Registry.CurrentUser.OpenSubKey(@"LGL\DCS\GConvert",false);

         if (regKey == null)
            return;

         this.txtBaseDir.Text = (string) regKey.GetValue("BasePath");
      }
	}
}
